clear;close all;clc;

%Input data, file path
fname = 'C:\Users\mathi\OneDrive\01. Dokumenter\01. Masteroppgave\06. Engine testing\Optical setup masteroppgave\Images of objects\Glass object in printed jig\new setup\background new setup printed glass holder in chamber.tif'

%Get image info and number og pictures in series
info = imfinfo(fname);
num_images = numel(info);

%Inputs
num_im_skip = 1;

%For loop to read images with imread one by one. And at the same time do
%statistical calulations for each frame.

num_sel_images = 20;

frame0 = cell(1,num_sel_images);        % initial image, no flame
frame = cell(1,num_sel_images);         % image with flame

for k = 1 : num_sel_images
    
    [emp0,map] = imread(fname, k+num_im_skip);
	[emp,map] = imread(fname,k);
    frame0{1,k} = double(emp0); %convert to double varable type in order to calculate average later
    frame{1,k} = double(emp);
    
    temp0 = frame0{1,k}; %Just used at the end of the script to illustrate on image
    temp = frame{1,k};
    uavg0(k) = mean(mean(frame0{1,k}));             %Average value in each frame  
    uavg(k) = mean(mean(frame{1,k}));
    
end

mean_uavg0 = mean(uavg0);
mean_uavg = mean(uavg);
std_uavg0 = std(uavg0);
std_uavg = std(uavg);
std_filter_limit = 5*std_uavg0;

% Filtrer bort bilder med hyt standard avvik.
ind_filt = [];

for k = 1 : num_sel_images
    
    if (uavg0(k) > (mean_uavg0+std_filter_limit)) || (uavg0(k) < (mean_uavg0-std_filter_limit))
        
        ind_filt = [ind_filt,k];
        frame0{1,k} = [];
        
    end
end

% load('C:\Users\mathi\OneDrive\01. Dokumenter\MATLAB\prosjektoppgave\soot_mat.mat')

sum_elements = zeros(512,512);
count = 0;

for i = 1:num_sel_images
    
    num_elements = sum(size(frame0{1,i}));
    
    if num_elements ~= 0
        
        temp = frame0{1,i};
        sum_elements = sum_elements + temp;
        count = count + 1;
    
    end
  
end

frame0_mean = sum_elements/count;
I0= frame0_mean ;

%---------------------------
%filtere out extreme values from frame picture
%alt over dette fungerer

ind_filt2 = [];

for k = 1 : num_sel_images
    
    if (uavg(k) > (mean_uavg+std_filter_limit)) || (uavg(k) < (mean_uavg-std_filter_limit))
       
        ind_filt2 = [ind_filt2,k];
        frame{1,k} = [];
        
    end
end

count2 = 0;

for i = 1:num_sel_images
    
    num_elements = sum(size(frame{1,i}));
    
    if num_elements ~= 0
        
        temp = frame{1,i};
        %sum_elements = sum_elements + temp;
        count2 = count2 + 1;
    
    end
  
end

output_kl_image = cell(1,num_sel_images); %preallocate empty cell array for kl image
count3 = 0;

for i = 1:num_sel_images
    
    num_elements2 = sum(size(frame{1,i}));
    
    if num_elements2 ~= 0
        
        output_kl_image{1,i} = I0 ./ frame{1,i} ;
        output_kl_image{1,i} = log(output_kl_image{1,i});
        output_kl_image{1,i}(isinf(output_kl_image{1,i})) = 0; %replace inf with 0  
        output_kl_image{1,i}(isnan(output_kl_image{1,i})) = 0; %replace nan with 0 ;
        count3 = count3 + i;
    
    end
  
end

output_kl_image(:,ind_filt2)=[]; %remove empty columns 

% %imadjust(output_kl_image{1,1});
% imwrite(output_kl_image{1,1},'KL_map_output.tif');
% 
% for i = 2 : count3
%     
%     %imadjust(output_kl_image{1,i});
%     imwrite(output_kl_image{1,i},'KL_map_output.tif','WriteMode','append')
%         
% end
% 
 figure
 imtool(output_kl_image{1,36},[-1 1])

%-------------------------- 
%create mean frame for soot sample. Do this to determinete soot impact on
%total signal

sum_elements_3 = zeros(512,512);
count4 = 0;

for i = 1:num_sel_images
    
    num_elements_3 = sum(size(frame{1,i}));
    
    if num_elements_3 ~= 0
        
        temp = frame{1,i};
        sum_elements_3 = sum_elements_3 + temp;
        count4 = count4 + 1;
    
    end
  
end

frame_mean_flame = sum_elements_3/count4;
I= frame_mean_flame ;

soot_frame = (frame_mean_flame)-(frame0_mean) ; %take example frame to create soot for picture for illustration
 
figure
imtool(soot_frame, [-1300 0]); 

random_kl_frame = (output_kl_image{1,36}) ;
SNR_across_center_random_kl_frame = random_kl_frame(128,:);
figure
plot(SNR_across_center_random_kl_frame);

% Find average value standard deviation in background
SNR_background_kl_image = SNR_across_center_random_kl_frame(20:115);
avg_snr_bg_kl_image= mean(SNR_background_kl_image);
std_SNR_bg_kl_image= std(SNR_background_kl_image);

% Noise in the flame/soot region should be the same as in the background region

%Soot signal impact on KL image
SNR_flame_kl_image = SNR_across_center_random_kl_frame(122:147);
avg_SNR_flame_kl_image = mean(SNR_flame_kl_image);

SNR_relative=(abs(avg_SNR_flame_kl_image) / abs(std_SNR_bg_kl_image))





